<template>
  <v-container>
    <v-breadcrumbs class="px-0" :items="items"></v-breadcrumbs>

    <v-row no-gutters class="d-flex align-center">
      <h1>Novo Projeto</h1>
      <v-spacer></v-spacer>
      <v-btn depressed small color="warning" to="/projects/">VOLTAR</v-btn>
    </v-row>
    <v-divider></v-divider>
    <div id="projects">
      <p>Preencha o formulário:</p>

      <v-form v-model="valid">
        <v-container>
          <v-row>
            <v-col cols="12" md="12">
              <v-text-field
                v-model="project.description"
                :rules="descriptionRules"
                label="Descrição"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="project.main_image" label="Imagem principal" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="project.attachments" label="Imagem secundária"></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="project.category" label="Categoria/Tipo" required></v-text-field>
            </v-col>

            <v-col cols="12" md="12">
              <div>
                <p>Publicar projeto</p>
                <v-checkbox v-model="checkbox1" label="Sim"></v-checkbox>
              </div>
            </v-col>
          </v-row>
        </v-container>
        <v-row>
          <v-btn depressed color="success" @click="salvar">SALVAR</v-btn>
          <v-spacer></v-spacer>
          <v-btn depressed color="primary" @click="visualizar">PRÉ VISUALIZAR</v-btn>
        </v-row>
      </v-form>
      <v-row>
        <v-spacer></v-spacer>
      </v-row>
    </div>
  </v-container>
</template>

<script>
import axios from "axios";
export default {
  data: () => ({
    valid: false,
    checkbox1: "",
    project: {
      description: "",
      attachments: "",
      post: "",
      main_image: "",
      category: ""
    },
    edit: false,
    descriptionRules: [v => !!v || "Nome é obrigatório"],
    dateRules: [],
    valueRules: [],
    items: [
      {
        text: "Dashboard",
        disabled: false,
        to: "/"
      },
      {
        text: "Projetos",
        disabled: false,
        exact: true,
        to: "/projects"
      },
      {
        text: "Cadastrar projeto",
        disabled: true
      }
    ]
  }),
  methods: {
    salvar() {
      if (this.edit == false) {
        console.log("salvar");
        console.log(this.project);
        axios
          .post("https://young-forest-65938.herokuapp.com/api/v1/projects", {
            description: this.project.description,
            attachments: this.project.attachments,
            post: this.project.post,
            main_image: this.project.main_image,
            category: this.project.category
          })
          .then(function(response) {
            console.log(this.project);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/projects");
      } else {
        console.log("editar else");
        axios
          .put(
            `https://young-forest-65938.herokuapp.com/api/v1/projects/${this.$router.currentRoute.query.id}`,
            {
              description: this.project.description,
              attachments: this.project.attachments,
              post: this.project.post,
              main_image: this.project.main_image,
              category: this.project.category
            }
          )
          .then(function(response) {
            console.log(this.demand);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/projects");
      }
    }
  },
  mounted() {
    console.log(this.$router.currentRoute.query.id);
    if (this.$router.currentRoute.query.id != null) {
      this.edit = true;
      console.log(this.$router.currentRoute.query.id);
      console.log("if mounted");
      return axios
        .get(
          `https://young-forest-65938.herokuapp.com/api/v1/projects/${this.$router.currentRoute.query.id}`
        )
        .then(response => {
          var resp = response.data;
          this.project = resp.data;
          console.log(this.project);
        });
    }
  }
};
</script>
